# R to common-lisp translator: example R code
# benchmark function in R, see http://dan.corlan.net/bench.html
#
# Copyright (c) 2005--2006 Alexandru Dan Corlan
# this code is released under the GNU General Public Licence V2.
# (see http://www.gnu.org/copyleft/gpl.html for details)
#
# the 'declare' and 'let' functions take any number of arguments
# and do nothing when interpreted; they are void functions
# declared in declet.R; however, the calls are translated
# by R2cl into common-lisp forms which are then macroexpanded
# into declarations that give the compiler hints about how to
# optimize


trpol2 <- function(n,x) {
  declare(int,n,
      scalar,x)
  let(scalar,mu,
      scalar,pu,
      vectorial,pol,
      scalar,tp1,
      scalar,tm1,
      scalar,s)
  mu <<- 10.0
  pu <<- 0.0
  pol <<- 1:100
  tp1 <<- 2.0
  tm1 <<- 1/2.0
  for (i in 1:n) {
    for (j in 1:100) {
      mu <<- (mu + tp1) * tm1
      pol[j] <<- mu
    }
    s <<- 0.0;
    for (j in 1:100) {
      s <<- x*s + pol[j];
    }
    pu <- s+pu;
  }
  print(pu)
}
