# R to common-lisp translator: example R code
# benchmark function in R, see http://dan.corlan.net/bench.html
#
# Copyright (c) 2005--2006 Alexandru Dan Corlan
# this code is released under the GNU General Public Licence V2.
# (see http://www.gnu.org/copyleft/gpl.html for details)
#
# Homepage: http://dan.corlan.net/R_to_common_lisp_translator
#
# R convertor which generates a compilable commonlisp file
# from an R file. Call the function R2cl.file(filename)
# and it will produce common-lisp code on the standard
# output, to be interpreted or compiled in cmu common-lisp
#
# V 0.1: jan 7 2006; proof of concept implementation for
#        the sole purpose to achieve translation and
#        of the trpol2.R benchmark into an efficiently
#        compilable form

R2cl.file <- function(file) {
  cat("(require \"rruntime\" \"rruntime.x86f\")\n\n")
  prsd <- as.list(parse(file))
  for (it in prsd)
   R2cl(it)
}

R2cl <- function(sexpr) {
  if(mode(sexpr)=="name") 
     { nm <- as.character(sexpr)
       
       if(nm==":")
         cat("seq ")
       else if (nm=="+")
	 cat("R+ ")
       else if (nm=="-")
	 cat("R- ")
       else if (nm=="*")
	 cat("R* ")
       else if (nm=="/")
	 cat("R/ ")
       else if (nm=="^")
	 cat("R** ")
       else if (nm=="[")
	 cat("R-elt ")
       else if (nm=="{")
	 cat("R-progn ")
       else if (nm=="let")
	 cat("R-let ")
       else if (nm=="declare")
	 cat("R-declare ")
       else 
         cat(sexpr, " ")
     }
  else if(mode(sexpr)=="numeric")
        cat(format(sexpr), " ")
  else if(mode(sexpr)=="character")
        cat("\"", sexpr, "\" ")
  else if(mode(sexpr)=="(")
	R2cl(sexpr[[2]])
  else if(mode(sexpr)=="NULL") {}
  else if(mode(sexpr)=="list") {
        cat('(')
        for (i in sexpr)
          R2cl(i)
	if(mode(sexpr[[1]])=="name")
	  if(as.character(sexpr[[1]])=="{")
             cat(" nil ")
        cat(')\n')
  } else if(mode(sexpr)=="pairlist") { #quick hack for pairlists in function definitions
        cat('(')
        for (i in names(sexpr))
          cat(i," ")
        cat(')\n')
  } else if(mode(sexpr)=="call")
        R2cl(as.list(sexpr))
  else cat("unknown mode: ", mode(sexpr), "\n")
}